## libvalhalla 1.0.1

=== Makefile ===
ifeq (,$(wildcard config.mak))
$(error "config.mak is not present, run configure !")
endif
include config.mak

PKGCONFIG_DIR = $(libdir)/pkgconfig
PKGCONFIG_FILE = libvalhalla.pc

VHTEST = libvalhalla-test
VHTEST_SRCS = libvalhalla-test.c
VHTEST_OBJS = $(VHTEST_SRCS:.c=.o)

override CPPFLAGS += -Isrc
override LDFLAGS += -Lsrc -lvalhalla

ifeq ($(BUILD_STATIC),yes)
  override LDFLAGS += $(EXTRALIBS)
endif

DISTFILE = libvalhalla-$(VERSION).tar.bz2

EXTRADIST = \
	AUTHORS \
	ChangeLog \
	configure \
	COPYING \
	README \
	TODO \

SUBDIRS = \
	DOCS \
	src \
	utils \

.SUFFIXES: .c .o

all: lib apps docs

.c.o:
	$(CC) -c $(OPTFLAGS) $(CFLAGS) $(CPPFLAGS) -o $@ $<

lib:
	$(MAKE) -C src

$(VHTEST): $(VHTEST_OBJS)
	$(CC) $(VHTEST_OBJS) $(LDFLAGS) -o $(VHTEST)

apps-dep:
	$(CC) -MM $(CFLAGS) $(CPPFLAGS) $(VHTEST_SRCS) 1>.depend

apps: apps-dep lib
	$(MAKE) $(VHTEST)

docs:
	$(MAKE) -C DOCS

docs-clean:
	$(MAKE) -C DOCS clean

clean:
	$(MAKE) -C src clean
	rm -f *.o
	rm -f $(VHTEST)
	rm -f .depend

distclean: clean docs-clean
	rm -f config.log
	rm -f config.mak
	rm -f $(DISTFILE)
	rm -f $(PKGCONFIG_FILE)

install: install-lib install-pkgconfig install-apps install-docs

install-lib: lib
	$(MAKE) -C src install

install-pkgconfig: $(PKGCONFIG_FILE)
	$(INSTALL) -d "$(PKGCONFIG_DIR)"
	$(INSTALL) -m 644 $< "$(PKGCONFIG_DIR)"

install-apps: apps
	$(INSTALL) -d $(bindir)
	$(INSTALL) -c -m 755 $(VHTEST) $(bindir)

install-docs: docs
	$(MAKE) -C DOCS install

uninstall: uninstall-lib uninstall-pkgconfig uninstall-apps uninstall-docs

uninstall-lib:
	$(MAKE) -C src uninstall

uninstall-pkgconfig:
	rm -f $(PKGCONFIG_DIR)/$(PKGCONFIG_FILE)

uninstall-apps:
	rm -f $(bindir)/$(VHTEST)

uninstall-docs:
	$(MAKE) -C DOCS uninstall

.PHONY: *clean *install* docs apps*

dist:
	-$(RM) $(DISTFILE)
	dist=$(shell pwd)/libvalhalla-$(VERSION) && \
	for subdir in . $(SUBDIRS); do \
		mkdir -p "$$dist/$$subdir"; \
		$(MAKE) -C $$subdir dist-all DIST="$$dist/$$subdir"; \
	done && \
	tar cjf $(DISTFILE) libvalhalla-$(VERSION)
	-$(RM) -rf libvalhalla-$(VERSION)

dist-all:
	cp $(EXTRADIST) $(VHTEST_SRCS) Makefile $(DIST)

.PHONY: dist dist-all

#
# include dependency files if they exist
#
ifneq ($(wildcard .depend),)
include .depend
endif

=== DOCS/Makefile ===
ifeq (,$(wildcard ../config.mak))
$(error "../config.mak is not present, run configure !")
endif
include ../config.mak

EXTRADIST = \
	Doxyfile \
	valhalla-db.png \
	valhalla-internals.png \

all: doxygen

doxygen:
ifeq ($(DOC),yes)
ifeq (,$(wildcard doxygen))
	PROJECT_NUMBER="$(VERSION)" doxygen Doxyfile
endif
endif

clean:
	rm -rf doxygen

install:
ifeq ($(DOC),yes)
	if [ -d doxygen/html ]; then \
		$(INSTALL) -d $(docdir)/libvalhalla; \
		$(INSTALL) -c -m 755 doxygen/html/* $(docdir)/libvalhalla; \
	fi
endif

uninstall:
	rm -rf $(docdir)/libvalhalla

dist-all:
	cp $(EXTRADIST) Makefile $(DIST)

.PHONY: clean dist-all doxygen *install

=== src/Makefile ===
ifeq (,$(wildcard ../config.mak))
$(error "../config.mak is not present, run configure !")
endif
include ../config.mak

ifeq ($(BUILD_STATIC),yes)
  BUILD_RULES += lib_static
endif
ifeq ($(BUILD_SHARED),yes)
  BUILD_RULES += lib_shared
endif

LIBNAME = libvalhalla
STATIC_LIBNAME = ${LIBNAME}.a
SHARED_LIBNAME = ${LIBNAME}.so
SHARED_LIBNAME_VERSION = ${SHARED_LIBNAME}.${VERSION}
SHARED_LIBNAME_MAJOR = $(SHARED_LIBNAME).$(shell echo $(VERSION) | cut -f1 -d.)

SRCS =  database.c \
	dbmanager.c \
	dispatcher.c \
	event_handler.c \
	fifo_queue.c \
	lavf_utils.c \
	list.c \
	logs.c \
	metadata.c \
	ondemand.c \
	parser.c \
	scanner.c \
	thread_utils.c \
	timer_thread.c \
	utils.c \
	valhalla.c \

EXTRADIST = \
	database.h \
	dbmanager.h \
	dispatcher.h \
	downloader.h \
	event_handler.h \
	fifo_queue.h \
	grabber.h \
	grabber_allocine.h \
	grabber_amazon.h \
	grabber_common.h \
	grabber_dummy.h \
	grabber_exif.h \
	grabber_ffmpeg.h \
	grabber_imdb.h \
	grabber_lastfm.h \
	grabber_local.h \
	grabber_lyricsfly.h \
	grabber_lyricwiki.h \
	grabber_nfo.h \
	grabber_tmdb.h \
	grabber_tvdb.h \
	grabber_tvrage.h \
	grabber_utils.h \
	hmac_sha256.h \
	lavf_utils.h \
	list.h \
	logs.h \
	md5.h \
	metadata.h \
	ondemand.h \
	parser.h \
	scanner.h \
	sql_statements.h \
	thread_utils.h \
	timer_thread.h \
	url_utils.h \
	utils.h \
	valhalla.h \
	valhalla_internals.h \
	xml_utils.h \

SRCS_GRABBER-$(GRABBER)			+= downloader.c \
					   grabber.c \
					   grabber_utils.c \
					   url_utils.c \

SRCS_GRABBER-$(XML)			+= xml_utils.c
SRCS_GRABBER-$(MD5)			+= md5.c
SRCS_GRABBER-$(HMAC_SHA256)		+= hmac_sha256.c
SRCS_GRABBER-$(GRABBER_DUMMY)		+= grabber_dummy.c
SRCS_GRABBER-$(GRABBER_ALLOCINE)	+= grabber_allocine.c
SRCS_GRABBER-$(GRABBER_AMAZON)		+= grabber_amazon.c
SRCS_GRABBER-$(GRABBER_EXIF)		+= grabber_exif.c
SRCS_GRABBER-$(GRABBER_FFMPEG)		+= grabber_ffmpeg.c
SRCS_GRABBER-$(GRABBER_IMDB)		+= grabber_imdb.c
SRCS_GRABBER-$(GRABBER_LASTFM)		+= grabber_lastfm.c
SRCS_GRABBER-$(GRABBER_LOCAL)		+= grabber_local.c
SRCS_GRABBER-$(GRABBER_LYRICSFLY)	+= grabber_lyricsfly.c
SRCS_GRABBER-$(GRABBER_LYRICWIKI)	+= grabber_lyricwiki.c
SRCS_GRABBER-$(GRABBER_NFO)		+= grabber_nfo.c
SRCS_GRABBER-$(GRABBER_TMDB)		+= grabber_tmdb.c
SRCS_GRABBER-$(GRABBER_TVDB)		+= grabber_tvdb.c
SRCS_GRABBER-$(GRABBER_TVRAGE)		+= grabber_tvrage.c

SRCS += $(SRCS_GRABBER-yes)

OBJS = $(SRCS:.c=.o)

.SUFFIXES: .c .o

all: depend $(BUILD_RULES)

.c.o:
	$(CC) -c $(OPTFLAGS) $(CFLAGS) $(CPPFLAGS) -o $@ $<

lib_static: $(STATIC_LIBNAME)

lib_shared: $(SHARED_LIBNAME)

$(STATIC_LIBNAME): $(OBJS)
	$(AR) r $(STATIC_LIBNAME) $(OBJS)
	$(RANLIB) $(STATIC_LIBNAME)

$(SHARED_LIBNAME): $(OBJS)
	$(CC) -shared -Wl,-soname,$(SHARED_LIBNAME_MAJOR) \
	  $(OBJS) $(LDFLAGS) $(EXTRALIBS) -o $(SHARED_LIBNAME_VERSION)
	$(LN) -sf $(SHARED_LIBNAME_VERSION) $(SHARED_LIBNAME_MAJOR)
	$(LN) -sf $(SHARED_LIBNAME_MAJOR) $(SHARED_LIBNAME)

clean:
	rm -f *.o *.a *.so*
	rm -f .depend

install: $(BUILD_RULES)
	$(INSTALL) -d $(libdir)
	[ $(BUILD_STATIC) = yes ] && $(INSTALL) -c $(STATIC_LIBNAME) $(libdir); \
	if [ $(BUILD_SHARED) = yes ]; then \
	  $(INSTALL) -c $(SHARED_LIBNAME_VERSION) $(libdir); \
	  $(LN) -sf $(SHARED_LIBNAME_VERSION) $(libdir)/$(SHARED_LIBNAME_MAJOR); \
	  $(LN) -sf $(SHARED_LIBNAME_MAJOR) $(libdir)/$(SHARED_LIBNAME); \
	fi
	$(INSTALL) -d $(includedir)
	$(INSTALL) -c -m 644 valhalla.h $(includedir)

uninstall:
	rm -f $(libdir)/$(STATIC_LIBNAME)
	rm -f $(libdir)/$(SHARED_LIBNAME)*
	rm -f $(includedir)/valhalla.h

depend:
	$(CC) -MM $(CFLAGS) $(CPPFLAGS) $(SRCS) 1>.depend

.PHONY: clean depend
.PHONY: uninstall

dist-all:
	cp $(EXTRADIST) $(SRCS) $(SRCS_GRABBER-no) Makefile $(DIST)

.PHONY: dist-all

#
# include dependency files if they exist
#
ifneq ($(wildcard .depend),)
include .depend
endif

=== debian/changelog ===
libvalhalla (1.0.1-2) unstable; urgency=low

  * Enable the ffmpeg grabber:
    - add Build-Depends: libavcodec-dev (>= 0.5.1)
    - update symbols file
  * Update Standards-Version to 3.8.4 (no changes).
  * Convert patch headers to DEP-3 format.
  * Convert copyright file to DEP-5 format.
  * Add debian/upstream-metadata.yaml.
  * Conflict with libnfo >= 2.0.0 to ease future upgrades.

 -- Davide Cavalca <davide@geexbox.org>  Sun, 07 Mar 2010 10:49:40 +0100

libvalhalla (1.0.1-1) unstable; urgency=low

  * New upstream release:
    - drop backport-trunk-build-system-fixes.patch as it's now upstream
    - fixes FTBFS on kfreebsd-* and hurd archs
  * Don't install AUTHORS, it's redundant (the authors are already 
    listed in libvalhalla README and in Debian copyright file)
  * Sync libvalhalla-test manual page with upstream trunk
  * Add no-static-libvalhalla-test.patch to prevent static linking of
    libvalhalla-test binary
  * Don't add -fPIC to CFLAGS, it's not needed anymore thanks to the new
    --enable-pic configure option.

 -- Davide Cavalca <davide@geexbox.org>  Tue, 26 Jan 2010 14:06:13 +0100

libvalhalla (1.0.0-2) unstable; urgency=low

  * Add dev packages referenced by pkgconfig to libplayer-dev depends
  * Fix typo in libplayer-dev suggests

 -- Davide Cavalca <davide@geexbox.org>  Mon, 04 Jan 2010 15:54:12 +0100

libvalhalla (1.0.0-1) unstable; urgency=low

  * Initial release (Closes: #560047)

 -- Davide Cavalca <davide@geexbox.org>  Thu, 10 Dec 2009 15:02:42 +0100

=== debian/control ===
Source: libvalhalla
Priority: extra
Maintainer: Davide Cavalca <davide@geexbox.org>
Build-Depends: debhelper (>= 7.0.50), libxml2-dev, pkg-config, libcurl4-dev | libcurl4-gnutls-dev, libnfo-dev (>= 1.0.0), libgcrypt-dev, libexif-dev, libsqlite3-dev, libavformat-dev, libavutil-dev, libavcodec-dev (>= 4:0.5.1)
Build-Conflicts: libnfo-dev (>= 2.0.0)
Build-Depends-Indep: doxygen
Standards-Version: 3.8.4
Section: libs
Homepage: http://libvalhalla.geexbox.org/
Vcs-Hg: http://hg.geexbox.org/libvalhalla
Vcs-Browser: http://hg.geexbox.org/libvalhalla/summary

Package: libvalhalla-dev
Section: libdevel
Architecture: any
Depends: libvalhalla1 (= ${binary:Version}), libxml2-dev, libcurl4-dev | libcurl4-gnutls-dev, libnfo-dev (>= 1.0.0), libgcrypt-dev, libexif-dev, libsqlite3-dev, libavformat-dev, libavutil-dev, libavcodec-dev (>= 4:0.5.1), ${misc:Depends}
Suggests: libvalhalla1-dbg (= ${binary:Version}), libvalhalla-doc (= ${binary:Version})
Conflicts: libnfo-dev (>= 2.0.0)
Description: a tiny media scanner library -- development files
 libvalhalla is a scanner and parser library for audio/video files based
 on SQLite and FFmpeg/libavformat.
 .
 Media files are retrieved in paths defined by the user and metadata are
 saved in a database. It provides a very simple API and it can use
 several parsers concurrently to speed up on a multi-core/cpu system.
 .
 This package contains headers and libraries for developing software
 that makes use of libvalhalla.

Package: libvalhalla1-bin
Section: misc
Architecture: any
Depends: libvalhalla1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: test utilities for libvalhalla
 libvalhalla is a scanner and parser library for audio/video files based
 on SQLite and FFmpeg/libavformat.
 .
 Media files are retrieved in paths defined by the user and metadata are
 saved in a database. It provides a very simple API and it can use
 several parsers concurrently to speed up on a multi-core/cpu system.
 .
 This package contains libvalhalla-test, an media indexing utility based
 on libvalhalla.

Package: libvalhalla1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: a tiny media scanner library
 libvalhalla is a scanner and parser library for audio/video files based
 on SQLite and FFmpeg/libavformat.
 .
 Media files are retrieved in paths defined by the user and metadata are
 saved in a database. It provides a very simple API and it can use
 several parsers concurrently to speed up on a multi-core/cpu system.

Package: libvalhalla1-dbg
Architecture: any
Section: debug
Depends: libvalhalla1 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for libvalhalla1
 libvalhalla is a scanner and parser library for audio/video files based
 on SQLite and FFmpeg/libavformat.
 .
 Media files are retrieved in paths defined by the user and metadata are
 saved in a database. It provides a very simple API and it can use
 several parsers concurrently to speed up on a multi-core/cpu system.
 .
 This package contains the debugging symbols for libvalhalla1.

Package: libvalhalla-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libvalhalla-dev
Description: developer documentation for libvalhalla
 libvalhalla is a scanner and parser library for audio/video files based
 on SQLite and FFmpeg/libavformat.
 .
 Media files are retrieved in paths defined by the user and metadata are
 saved in a database. It provides a very simple API and it can use
 several parsers concurrently to speed up on a multi-core/cpu system.
 .
 This package contains developer documentation for libvalhalla.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CONFIGURE_OPTS = --prefix=/usr --enable-pic --disable-strip --enable-doc

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
        CONFIGURE_OPTS += --disable-optimize
else
        CONFIGURE_OPTS += 
endif

%:
	dh $@

override_dh_auto_configure:
	./configure $(CONFIGURE_OPTS)

override_dh_strip:
	dh_strip --dbg-package=libvalhalla1-dbg

.PHONY: override_dh_auto_configure override_dh_strip

## libvalhalla 2.0.0

=== Makefile ===
--- 
+++ 
@@ -9,12 +9,17 @@
 VHTEST = libvalhalla-test
 VHTEST_SRCS = libvalhalla-test.c
 VHTEST_OBJS = $(VHTEST_SRCS:.c=.o)
+VHTEST_MAN = $(VHTEST).1
 
-override CPPFLAGS += -Isrc
-override LDFLAGS += -Lsrc -lvalhalla
+APPS_CPPFLAGS = -Isrc $(CFG_CPPFLAGS) $(CPPFLAGS)
+APPS_LDFLAGS = -Lsrc -lvalhalla $(CFG_LDFLAGS) $(LDFLAGS)
+
+MANS = $(VHTEST_MAN)
 
 ifeq ($(BUILD_STATIC),yes)
-  override LDFLAGS += $(EXTRALIBS)
+ifeq ($(BUILD_SHARED),no)
+  APPS_LDFLAGS += $(EXTRALIBS)
+endif
 endif
 
 DISTFILE = libvalhalla-$(VERSION).tar.bz2
@@ -26,10 +31,12 @@
 	COPYING \
 	README \
 	TODO \
+	$(MANS) \
 
 SUBDIRS = \
 	DOCS \
 	src \
+	tests \
 	utils \
 
 .SUFFIXES: .c .o
@@ -37,16 +44,21 @@
 all: lib apps docs
 
 .c.o:
-	$(CC) -c $(OPTFLAGS) $(CFLAGS) $(CPPFLAGS) -o $@ $<
+	$(CC) -c $(OPTFLAGS) $(CFLAGS) $(APPS_CPPFLAGS) -o $@ $<
+
+config.mak: configure
+	@echo "############################################################"
+	@echo "####### Please run ./configure again - it's changed! #######"
+	@echo "############################################################"
 
 lib:
 	$(MAKE) -C src
 
 $(VHTEST): $(VHTEST_OBJS)
-	$(CC) $(VHTEST_OBJS) $(LDFLAGS) -o $(VHTEST)
+	$(CC) $(VHTEST_OBJS) $(APPS_LDFLAGS) -o $(VHTEST)
 
 apps-dep:
-	$(CC) -MM $(CFLAGS) $(CPPFLAGS) $(VHTEST_SRCS) 1>.depend
+	$(CC) -MM $(CFLAGS) $(APPS_CPPFLAGS) $(VHTEST_SRCS) 1>.depend
 
 apps: apps-dep lib
 	$(MAKE) $(VHTEST)
@@ -57,19 +69,25 @@
 docs-clean:
 	$(MAKE) -C DOCS clean
 
+tests:
+	$(MAKE) -C tests
+
+tests-clean:
+	$(MAKE) -C tests clean
+
 clean:
 	$(MAKE) -C src clean
 	rm -f *.o
 	rm -f $(VHTEST)
 	rm -f .depend
 
-distclean: clean docs-clean
+distclean: clean docs-clean tests-clean
 	rm -f config.log
 	rm -f config.mak
 	rm -f $(DISTFILE)
 	rm -f $(PKGCONFIG_FILE)
 
-install: install-lib install-pkgconfig install-apps install-docs
+install: install-lib install-pkgconfig install-apps install-docs install-man
 
 install-lib: lib
 	$(MAKE) -C src install
@@ -85,7 +103,14 @@
 install-docs: docs
 	$(MAKE) -C DOCS install
 
-uninstall: uninstall-lib uninstall-pkgconfig uninstall-apps uninstall-docs
+install-man: $(MANS)
+	for m in $(MANS); do \
+	  section=`echo $$m | sed -e 's/^.*\\.//'`; \
+	  $(INSTALL) -d $(mandir)/man$$section; \
+	  $(INSTALL) -m 644 $$m $(mandir)/man$$section; \
+	done
+
+uninstall: uninstall-lib uninstall-pkgconfig uninstall-apps uninstall-docs uninstall-man
 
 uninstall-lib:
 	$(MAKE) -C src uninstall
@@ -99,7 +124,13 @@
 uninstall-docs:
 	$(MAKE) -C DOCS uninstall
 
-.PHONY: *clean *install* docs apps*
+uninstall-man:
+	for m in $(MANS); do \
+	  section=`echo $$m | sed -e 's/^.*\\.//'`; \
+	  rm -f $(mandir)/man$$section/$$m; \
+	done
+
+.PHONY: *clean *install* docs tests apps*
 
 dist:
 	-$(RM) $(DISTFILE)

=== DOCS/Makefile ===
--- 
+++ 
@@ -4,21 +4,54 @@
 include ../config.mak
 
 EXTRADIST = \
+	curl.png \
 	Doxyfile \
+	ffmpeg.png \
+	priorities.txt \
+	sqlite3.png \
+	states_ffmpeg_01.dia \
+	states_general.dia \
+	states_grabbers_01.dia \
+	states_grabbers_lock.dia \
+	states_ondemand_01.dia \
+	valhalla.eps \
+	valhalla.lyx \
+	valhalla.svg \
+	valhalla-db.dia \
 	valhalla-db.png \
+	valhalla-internals.dia \
 	valhalla-internals.png \
 
-all: doxygen
+all: doxygen lyx
 
 doxygen:
 ifeq ($(DOC),yes)
+ifeq ($(DOC_DOXYGEN),yes)
 ifeq (,$(wildcard doxygen))
 	PROJECT_NUMBER="$(VERSION)" doxygen Doxyfile
+endif
+endif
+endif
+
+lyx:
+ifeq ($(DOC),yes)
+ifeq ($(DOC_LYX),yes)
+ifeq (,$(wildcard valhalla-$(VERSION).pdf))
+	sed 's,filename valhalla-internals.dia,filename valhalla-internals.tmp.dia,' valhalla.lyx > valhalla.tmp.lyx
+	sed -e 's,\./curl.png,$(shell pwd)/curl.png,' \
+	    -e 's,\./ffmpeg.png,$(shell pwd)/ffmpeg.png,' \
+	    -e 's,\./sqlite3.png,$(shell pwd)/sqlite3.png,' \
+            valhalla-internals.dia > valhalla-internals.tmp.dia
+	lyx valhalla.tmp.lyx -e pdf2
+	mv valhalla.tmp.pdf valhalla-$(VERSION).pdf
+	rm -f *.tmp.*
+endif
 endif
 endif
 
 clean:
 	rm -rf doxygen
+	rm -f valhalla-$(VERSION).pdf
 
 install:
 ifeq ($(DOC),yes)
@@ -34,4 +67,4 @@
 dist-all:
 	cp $(EXTRADIST) Makefile $(DIST)
 
-.PHONY: clean dist-all doxygen *install
+.PHONY: clean dist-all doxygen *install lyx

=== src/Makefile ===
ifeq (,$(wildcard ../config.mak))
$(error "../config.mak is not present, run configure !")
endif
include ../config.mak

LIBNAME = libvalhalla
STATIC_LIBNAME = $(LIBNAME).a
SHARED_LIBNAME = $(LIBNAME).so
SHARED_LIBNAME_VERSION = $(SHARED_LIBNAME).$(VERSION)
SHARED_LIBNAME_MAJOR = $(SHARED_LIBNAME).$(shell echo $(VERSION) | cut -f1 -d.)
SHARED_LIBNAME_FLAGS = -shared -Wl,-soname,$(SHARED_LIBNAME_MAJOR)

ifeq ($(BUILD_STATIC),yes)
  BUILD_RULES += lib_static
endif
ifeq ($(BUILD_SHARED),yes)
  BUILD_RULES += lib_shared
  ifeq ($(BUILD_DYLIB),yes)
    SHARED_LIBNAME         = $(LIBNAME).dylib
    SHARED_LIBNAME_VERSION = $(LIBNAME).$(VERSION).dylib
    SHARED_LIBNAME_MAJOR   = $(LIBNAME).$(shell echo $(VERSION) | cut -f1 -d.).dylib
    SHARED_LIBNAME_FLAGS   = -dynamiclib -Wl,-headerpad_max_install_names,-undefined,dynamic_lookup,-install_name,$(SHARED_LIBNAME_VERSION)
  else
    ifeq ($(BUILD_MINGW32),yes)
      SHARED_LIBNAME         = $(LIBNAME)-$(shell echo $(VERSION) | cut -f1 -d.).dll
      SHARED_LIBNAME_VERSION = $(SHARED_LIBNAME)
      SHARED_LIBNAME_MAJOR   = $(SHARED_LIBNAME)
      SHARED_LIBNAME_FLAGS   = -shared -Wl,--out-implib=$(LIBNAME).dll.a -Wl,--export-all-symbols -Wl,--enable-auto-import
    endif
  endif
endif

SRCS =  database.c \
	dbmanager.c \
	dispatcher.c \
	event_handler.c \
	fifo_queue.c \
	lavf_utils.c \
	list.c \
	logs.c \
	metadata.c \
	ondemand.c \
	osdep.c \
	parser.c \
	scanner.c \
	stats.c \
	thread_utils.c \
	timer_thread.c \
	utils.c \
	valhalla.c \

EXTRADIST = \
	database.h \
	dbmanager.h \
	dispatcher.h \
	downloader.h \
	event_handler.h \
	fifo_queue.h \
	grabber.h \
	grabber_allocine.h \
	grabber_amazon.h \
	grabber_chartlyrics.h \
	grabber_common.h \
	grabber_dummy.h \
	grabber_exif.h \
	grabber_ffmpeg.h \
	grabber_imdb.h \
	grabber_lastfm.h \
	grabber_local.h \
	grabber_lyricwiki.h \
	grabber_nfo.h \
	grabber_tmdb.h \
	grabber_tvdb.h \
	grabber_tvrage.h \
	grabber_utils.h \
	hmac_sha256.h \
	lavf_utils.h \
	list.h \
	logs.h \
	md5.h \
	metadata.h \
	ondemand.h \
	osdep.h \
	parser.h \
	scanner.h \
	sha.h \
	sql_statements.h \
	stats.h \
	thread_utils.h \
	timer_thread.h \
	url_utils.h \
	utils.h \
	valhalla.h \
	valhalla_internals.h \
	xml_utils.h \

SRCS_GRABBER-$(GRABBER)			+= downloader.c \
					   grabber.c \
					   grabber_utils.c \
					   url_utils.c \

SRCS_GRABBER-$(XML)			+= xml_utils.c
SRCS_GRABBER-$(MD5)			+= md5.c
SRCS_GRABBER-$(HMAC_SHA256)		+= hmac_sha256.c \
					   sha.c
SRCS_GRABBER-$(GRABBER_DUMMY)		+= grabber_dummy.c
SRCS_GRABBER-$(GRABBER_ALLOCINE)	+= grabber_allocine.c
SRCS_GRABBER-$(GRABBER_AMAZON)		+= grabber_amazon.c
SRCS_GRABBER-$(GRABBER_CHARTLYRICS)	+= grabber_chartlyrics.c
SRCS_GRABBER-$(GRABBER_EXIF)		+= grabber_exif.c
SRCS_GRABBER-$(GRABBER_FFMPEG)		+= grabber_ffmpeg.c
SRCS_GRABBER-$(GRABBER_IMDB)		+= grabber_imdb.c
SRCS_GRABBER-$(GRABBER_LASTFM)		+= grabber_lastfm.c
SRCS_GRABBER-$(GRABBER_LOCAL)		+= grabber_local.c
SRCS_GRABBER-$(GRABBER_LYRICWIKI)	+= grabber_lyricwiki.c
SRCS_GRABBER-$(GRABBER_NFO)		+= grabber_nfo.c
SRCS_GRABBER-$(GRABBER_TMDB)		+= grabber_tmdb.c
SRCS_GRABBER-$(GRABBER_TVDB)		+= grabber_tvdb.c
SRCS_GRABBER-$(GRABBER_TVRAGE)		+= grabber_tvrage.c

SRCS += $(SRCS_GRABBER-yes)

OBJS = $(SRCS:.c=.o)

.SUFFIXES: .c .o

all: depend $(BUILD_RULES)

.c.o:
	$(CC) -c $(OPTFLAGS) $(CFLAGS) $(CFG_CPPFLAGS) $(CPPFLAGS) -o $@ $<

lib_static: $(STATIC_LIBNAME)

lib_shared: $(SHARED_LIBNAME)

$(STATIC_LIBNAME): $(OBJS)
	$(AR) r $(STATIC_LIBNAME) $(OBJS)
	$(RANLIB) $(STATIC_LIBNAME)

$(SHARED_LIBNAME): $(OBJS)
	$(CC) $(SHARED_LIBNAME_FLAGS) \
	  $(OBJS) $(CFG_LDFLAGS) $(EXTRALIBS) $(LDFLAGS) -o $(SHARED_LIBNAME_VERSION)
	if [ $(BUILD_MINGW32) = no ]; then \
	  $(LN) -sf $(SHARED_LIBNAME_VERSION) $(SHARED_LIBNAME_MAJOR); \
	  $(LN) -sf $(SHARED_LIBNAME_MAJOR) $(SHARED_LIBNAME); \
	fi

clean:
	rm -f *.o *.a *.so* *.dll
	rm -f .depend

install: $(BUILD_RULES)
	$(INSTALL) -d $(libdir)
	[ $(BUILD_STATIC) = yes ] && $(INSTALL) -c $(STATIC_LIBNAME) $(libdir); \
	if [ $(BUILD_SHARED) = yes ]; then \
	  if [ $(BUILD_MINGW32) = no ]; then \
	    $(INSTALL) -c $(SHARED_LIBNAME_VERSION) $(libdir); \
	    $(LN) -sf $(SHARED_LIBNAME_VERSION) $(libdir)/$(SHARED_LIBNAME_MAJOR); \
	    $(LN) -sf $(SHARED_LIBNAME_MAJOR) $(libdir)/$(SHARED_LIBNAME); \
	  else \
	    $(INSTALL) -c $(SHARED_LIBNAME_VERSION) $(bindir); \
	    $(INSTALL) -c $(LIBNAME).dll.a $(libdir); \
	  fi \
	fi
	$(INSTALL) -d $(includedir)
	$(INSTALL) -c -m 644 valhalla.h $(includedir)

uninstall:
	if [ $(BUILD_MINGW32) = yes ]; then \
	  rm -f $(bindir)/$(SHARED_LIBNAME); \
	  rm -f $(libdir)/$(LIBNAME).dll.a; \
	fi
	rm -f $(libdir)/$(STATIC_LIBNAME)
	rm -f $(libdir)/$(SHARED_LIBNAME)*
	rm -f $(includedir)/valhalla.h

depend:
	$(CC) -MM $(CFLAGS) $(CFG_CPPFLAGS) $(CPPFLAGS) $(SRCS) 1>.depend

.PHONY: clean depend
.PHONY: uninstall

dist-all:
	cp $(EXTRADIST) $(SRCS) $(SRCS_GRABBER-no) Makefile $(DIST)

.PHONY: dist-all

#
# include dependency files if they exist
#
ifneq ($(wildcard .depend),)
include .depend
endif

=== tests/Makefile ===
ifeq (,$(wildcard ../config.mak))
$(error "../config.mak is not present, run configure !")
endif
include ../config.mak

VH_TEST = vh_test

APP_CPPFLAGS = -I../src $(CFG_CPPFLAGS) $(CPPFLAGS)
APP_LDFLAGS = -L../src -lcheck $(CFG_LDFLAGS) $(LDFLAGS)

APP_CPPFLAGS += -DOSDEP_STRNDUP -DOSDEP_STRCASESTR -DOSDEP_STRTOK_R

SRCS =  vh_suite.c \
	vh_test_osdep.c \

EXTRA_SRCS = \
	osdep.c \

EXTRADIST = \
	vh_test.h \

OBJS = $(SRCS:.c=.o) $(EXTRA_SRCS:.c=.o)

.SUFFIXES: .c .o

all: extra_srcs depend $(VH_TEST)

.c.o:
	$(CC) -c $(OPTFLAGS) $(CFLAGS) $(APP_CPPFLAGS) -o $@ $<

$(VH_TEST): $(OBJS)
	$(CC) $(OBJS) $(APP_LDFLAGS) -o $(VH_TEST)

extra_srcs:
	for l in $(EXTRA_SRCS); do \
	  ln -sf ../src/$$l ./; \
	done

clean:
	rm -f $(EXTRA_SRCS)
	rm -f *.o
	rm -f $(VH_TEST)
	rm -f .depend

depend:
	$(CC) -MM $(CFLAGS) $(CFG_CPPFLAGS) $(APP_CPPFLAGS) $(SRCS) $(EXTRA_SRCS) 1>.depend

.PHONY: clean depend extra_srcs $(EXTRA_SRCS)

dist-all:
	cp $(EXTRADIST) $(SRCS) Makefile $(DIST)

.PHONY: dist-all

#
# include dependency files if they exist
#
ifneq ($(wildcard .depend),)
include .depend
endif

=== utils/Makefile ===
ifeq (,$(wildcard ../config.mak))
$(error "../config.mak is not present, run configure !")
endif
include ../config.mak

EXTRADIST = \
	searchMovieAllocine.php \
	searchMovieIMDB.php \

dist-all:
	cp $(EXTRADIST) Makefile $(DIST)

.PHONY: dist-all

=== debian/changelog ===
libvalhalla (2.0.0-4) unstable; urgency=low

  * Drop deprecated curl includes (Closes: #637703)
  * Fix FTBFS with libav 0.7 (Closes: #635502)
  * Update Standards-Version to 3.9.2 (no changes)
  * Rework package description to fix lintian warning
    description-synopsis-starts-with-article

 -- Davide Cavalca <davide@geexbox.org>  Wed, 17 Aug 2011 09:37:15 +0200

libvalhalla (2.0.0-3) unstable; urgency=low

  * Correct Build-Depends on libcurl4-dev (Closes: #614989)
  * Backport add-lrt-to-ldflags.patch from upstream trunk, fixes FTBFS 
    when using binutils-gold (Closes: #601022)
  * Update copyright dates

 -- Davide Cavalca <davide@geexbox.org>  Fri, 25 Feb 2011 14:23:10 +0100

libvalhalla (2.0.0-2) unstable; urgency=low

  * Resolve file conflict between libvalhalla2-dbg and libvalhalla1-dbg
    (Closes: #599150)

 -- Davide Cavalca <davide@geexbox.org>  Tue, 05 Oct 2010 09:50:27 +0200

libvalhalla (2.0.0-1) unstable; urgency=low

  * New upstream release:
    - drop Debian package patches as they are now upstream
    - drop Debian manpages for libvalhalla-test util as it's now upstream
    - soname bump: libvalhalla1 -> libvalhalla2
  * Rename package libvalhalla1-bin to libvalhalla-bin
  * Update Standards-Version to 3.9.1 (no changes)
  * Drop Vcs-Pkg fields from control file (Closes: #574398)
  * Update copyright dates

 -- Davide Cavalca <davide@geexbox.org>  Mon, 04 Oct 2010 09:34:08 +0200

=== debian/control ===
Source: libvalhalla
Priority: extra
Maintainer: Davide Cavalca <davide@geexbox.org>
Build-Depends: debhelper (>= 7.0.50), libxml2-dev, pkg-config, libcurl4-gnutls-dev | libcurl4-dev, libnfo-dev (>= 1.0.0), libgcrypt-dev, libexif-dev, libsqlite3-dev, libavformat-dev, libavutil-dev, libavcodec-dev (>= 4:0.5.1)
Build-Conflicts: libnfo-dev (>= 2.0.0)
Build-Depends-Indep: doxygen
Standards-Version: 3.9.2
Section: libs
Homepage: http://libvalhalla.geexbox.org/

Package: libvalhalla-dev
Section: libdevel
Architecture: any
Depends: libvalhalla2 (= ${binary:Version}), libxml2-dev, libcurl4-gnutls-dev | libcurl4-dev, libnfo-dev (>= 1.0.0), libgcrypt-dev, libexif-dev, libsqlite3-dev, libavformat-dev, libavutil-dev, libavcodec-dev (>= 4:0.5.1), ${misc:Depends}
Suggests: libvalhalla2-dbg (= ${binary:Version}), libvalhalla-doc (= ${binary:Version})
Conflicts: libnfo-dev (>= 2.0.0)
Description: tiny media scanner library -- development files
 libvalhalla is a scanner and parser library for audio/video files based
 on SQLite and FFmpeg/libavformat.
 .
 Media files are retrieved in paths defined by the user and metadata are
 saved in a database. It provides a very simple API and it can use
 several parsers concurrently to speed up on a multi-core/cpu system.
 .
 This package contains headers and libraries for developing software
 that makes use of libvalhalla.

Package: libvalhalla-bin
Section: misc
Architecture: any
Depends: libvalhalla2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: libvalhalla1-bin
Replaces: libvalhalla1-bin
Conflicts: libvalhalla1-bin
Description: test utilities for libvalhalla
 libvalhalla is a scanner and parser library for audio/video files based
 on SQLite and FFmpeg/libavformat.
 .
 Media files are retrieved in paths defined by the user and metadata are
 saved in a database. It provides a very simple API and it can use
 several parsers concurrently to speed up on a multi-core/cpu system.
 .
 This package contains libvalhalla-test, an media indexing utility based
 on libvalhalla.

Package: libvalhalla2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tiny media scanner library
 libvalhalla is a scanner and parser library for audio/video files based
 on SQLite and FFmpeg/libavformat.
 .
 Media files are retrieved in paths defined by the user and metadata are
 saved in a database. It provides a very simple API and it can use
 several parsers concurrently to speed up on a multi-core/cpu system.

Package: libvalhalla2-dbg
Architecture: any
Section: debug
Depends: libvalhalla2 (= ${binary:Version}), ${misc:Depends}
Provides: libvalhalla1-dbg
Replaces: libvalhalla1-dbg
Conflicts: libvalhalla1-dbg
Description: debugging symbols for libvalhalla2
 libvalhalla is a scanner and parser library for audio/video files based
 on SQLite and FFmpeg/libavformat.
 .
 Media files are retrieved in paths defined by the user and metadata are
 saved in a database. It provides a very simple API and it can use
 several parsers concurrently to speed up on a multi-core/cpu system.
 .
 This package contains the debugging symbols for libvalhalla2.

Package: libvalhalla-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libvalhalla-dev
Description: developer documentation for libvalhalla
 libvalhalla is a scanner and parser library for audio/video files based
 on SQLite and FFmpeg/libavformat.
 .
 Media files are retrieved in paths defined by the user and metadata are
 saved in a database. It provides a very simple API and it can use
 several parsers concurrently to speed up on a multi-core/cpu system.
 .
 This package contains developer documentation for libvalhalla.

=== debian/rules ===
--- 
+++ 
@@ -19,6 +19,6 @@
 	./configure $(CONFIGURE_OPTS)
 
 override_dh_strip:
-	dh_strip --dbg-package=libvalhalla1-dbg
+	dh_strip --dbg-package=libvalhalla2-dbg
 
 .PHONY: override_dh_auto_configure override_dh_strip

=== debian/watch ===
version=3
http://libvalhalla.geexbox.org/releases/libvalhalla-(.*)\.tar\.bz2
